<script setup lang="ts">
import { onMounted, provide, ref } from 'vue'
import UserList from '@/components/UserList.vue'
import type { User } from '@/types/User'
import { useUserStore } from '@/stores/user'
import { useRoute, useRouter } from 'vue-router'
import { useAuthStore } from '@/stores/auth'
import { usePermissionStore } from '@/stores/permission'

const permissionStore = usePermissionStore()
const router = useRouter()
const route = useRoute()

const authStore = useAuthStore()
const userStore = useUserStore()
const p = ref<User[]>([])

provide('selectedUser', p)

const userList: User[] | any = ref(userStore.users)

onMounted(async () => {
  if (!permissionStore.isEmp()) {
    permissionStore.pushMember()
  } else if (authStore.getCurrentUser()?.role === 'Staff') {
    permissionStore.pushEmp()
  } 
  userList.value = userStore.users
  await userStore.getUsers()
})
</script>

<template>
  <UserList :users="userList"></UserList>
</template>
